// shsioctl.h
// osamu imaizumi 20-Feb-97
#define IOCTL_SERIAL_GET_SMC_PRESENT    CTL_CODE(FILE_DEVICE_SERIAL_PORT,0x900,METHOD_BUFFERED,FILE_ANY_ACCESS)
#define IOCTL_SERIAL_SET_SMC_PRESENT    CTL_CODE(FILE_DEVICE_SERIAL_PORT,0x910,METHOD_BUFFERED,FILE_ANY_ACCESS)

typedef struct  _SERIAL_SMC_PRESENT{
    ULONG SmcPresent;
}   SERIAL_SMC_PRESENT, *PSERIAL_SMC_PRESENT;

#define IOCTL_SERIAL_SET_FIXED_DIVISOR  CTL_CODE(FILE_DEVICE_SERIAL_PORT,0x930,METHOD_BUFFERED,FILE_ANY_ACCESS)

typedef struct  _SERIAL_SET_FIXED_DIVISOR{
    USHORT FixedDivisor;
    ULONG CurrentBaud;
}   SERIAL_SET_FIXED_DIVISOR, *PSERIAL_SET_FIXED_DIVISOR;
/*
 SmcPresent variable

 31              23              15               7             0
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |D|   Stab  |  PortAddress(10)  |    SMC ID(8)  |T|    Mode(7)  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 bit 31:
  Debug flag,
   if on, bit 30-0 write when IOCTL_SERIAL_SET_SMC_PRESENT
   if off, bit 6-0 write.
 bit 25-16:
  SMC Control Port Address, 3f0h or 370h
 bit 15- 8:
  SMC Chip ID
 bit 7:
  if on, SMC Type IV.(67x-957,not 665/666/669/669FR)
 bit 6-4:
  reserve.
 bit 3:
  if on, return real speed. The other return requested speed.(default)
 bit 2-0:
   Mode value.

  0: 16550 comaptible.
  1: x1 mode(default), 230400 and 460800bps support.
  2: x2 mode, actual speed = requested speed * 2.
  3: Always 230400bps, ignore requested speed.
  4: x4 mode, actual speed = requested speed * 4.
  5: Always 460800bps, ignore requested speed.
*/
